OpenTTD Source: BaseMedia< Tbase_set > Class Template Reference

OpenTTD Source 12.0-beta1

Static Public Member Functions | Static Public Attributes | Protected Member Functions | Static Protected Member Functions | Static Protected Attributes
BaseMedia< Tbase_set > Class Template Reference

Base for all base media (graphics, sounds) More...

`#include <base_media_base.h>`

Inheritance diagram for BaseMedia< Tbase_set >:

## Static Public Member Functions
static bool | DetermineBestSet ()
| Determine the graphics pack that has to be used. More...
static uint | FindSets ()
| Do the scan for files.
static Tbase_set * | GetAvailableSets ()
| Return the available sets. More...
static bool | SetSet (const std::string &name)
| Set the set to be used. More...
static char * | GetSetsList (char *p, const char *last)
| Returns a list with the sets. More...
static int | GetNumSets ()
| Count the number of available graphics sets. More...
static int | GetIndexOfUsedSet ()
| Get the index of the currently active graphics set. More...
static const Tbase_set * | GetSet (int index)
| Get the name of the graphics set at the specified index. More...
static const Tbase_set * | GetUsedSet ()
| Return the used set. More...
static bool | HasSet (const ContentInfo *ci, bool md5sum)
| Check whether we have an set with the exact characteristics as ci. More...

## Static Public Attributes
static std::string | ini_set
| The set as saved in the config file.

## Protected Member Functions
bool | AddFile (const std::string &filename, size_t basepath_length, const std::string &tar_filename) override
| Add a file with the given filename. More...

## Static Protected Member Functions
static const char * | GetExtension ()
| Get the extension that is used to identify this set. More...

## Static Protected Attributes
static Tbase_set * | available_sets
| All available sets.
static Tbase_set * | duplicate_sets
| All sets that aren't available, but needed for not downloading base sets when a newer version than the one on BaNaNaS is loaded.
static const Tbase_set * | used_set
| The currently used set.

## Additional Inherited Members
Private Member Functions inherited from FileScanner
virtual | ~FileScanner ()
| Destruct the proper one...
uint | Scan (const char *extension, Subdirectory sd, bool tars=true, bool recursive=true)
| Scan for files with the given extension in the given search path. More...
uint | Scan (const char *extension, const char *directory, bool recursive=true)
| Scan for files with the given extension in the given search path. More...
Private Attributes inherited from FileScanner
Subdirectory | subdir
| The current sub directory we are searching through.

## Detailed Description

### template<class Tbase_set>
class BaseMedia< Tbase_set >

Base for all base media (graphics, sounds)

Template Parameters

  Tbase_set | the real set we're going to be

Definition at line 164 of file base_media_base.h.

## Member Function Documentation

## ◆ AddFile()

template<class Tbase_set >

bool BaseMedia< Tbase_set >::AddFile | ( | const std::string & | filename,
|  | size_t | basepath_length,
|  | const std::string & | tar_filename
| ) |  |
| overrideprotectedvirtual

Add a file with the given filename.

Parameters

  filename | the full path to the file to read
  basepath_length | amount of characters to chop of before to get a filename relative to the search path.
  tar_filename | the name of the tar file the file is read from.

Returns
  true if the file is added.

Implements FileScanner.

Definition at line 153 of file base_media_func.h.

## ◆ DetermineBestSet()

template<class Tbase_set >

bool BaseMedia< Tbase_set >::DetermineBestSet
| static

Determine the graphics pack that has to be used.

The one with the most correct files wins.

Returns
  true if a best set has been found.

Definition at line 440 of file gfxinit.cpp.

## ◆ GetAvailableSets()

template<class Tbase_set >

Tbase_set * BaseMedia< Tbase_set >::GetAvailableSets
| static

Return the available sets.

Returns
  The available sets.

Definition at line 367 of file base_media_func.h.

## ◆ GetExtension()

template<class Tbase_set >

const char * BaseMedia< Tbase_set >::GetExtension
| staticprotected

Get the extension that is used to identify this set.

Returns
  the extension

Definition at line 464 of file gfxinit.cpp.

Referenced by BaseMedia< GraphicsSet >::FindSets().

## ◆ GetIndexOfUsedSet()

template<class Tbase_set >

int BaseMedia< Tbase_set >::GetIndexOfUsedSet
| static

Get the index of the currently active graphics set.

Returns
  the current set's index

Definition at line 326 of file base_media_func.h.

## ◆ GetNumSets()

template<class Tbase_set >

int BaseMedia< Tbase_set >::GetNumSets
| static

Count the number of available graphics sets.

Returns
  the number of sets

Definition at line 311 of file base_media_func.h.

## ◆ GetSet()

template<class Tbase_set >

const Tbase_set * BaseMedia< Tbase_set >::GetSet | ( | int | index | ) |
| static

Get the name of the graphics set at the specified index.

Returns
  the name of the set

Definition at line 342 of file base_media_func.h.

## ◆ GetSetsList()

template<class Tbase_set >

char * BaseMedia< Tbase_set >::GetSetsList | ( | char * | p,
|  | const char * | last
| ) |  |
| static

Returns a list with the sets.

Parameters

  p | where to print to
  last | the last character to print to

Returns
  the last printed character

Definition at line 255 of file base_media_func.h.

## ◆ GetUsedSet()

template<class Tbase_set >

const Tbase_set * BaseMedia< Tbase_set >::GetUsedSet
| static

Return the used set.

Returns
  the used set.

Definition at line 357 of file base_media_func.h.

## ◆ HasSet()

template<class Tbase_set >

bool BaseMedia< Tbase_set >::HasSet | ( | const ContentInfo * | ci,
|  | bool | md5sum
| ) |  |
| static

Check whether we have an set with the exact characteristics as ci.

Parameters

  ci | the characteristics to search on (shortname and md5sum)
  md5sum | whether to check the MD5 checksum

Returns
  true iff we have an set matching.

Definition at line 300 of file base_media_func.h.

## ◆ SetSet()

template<class Tbase_set >

bool BaseMedia< Tbase_set >::SetSet | ( | const std::string & | name | ) |
| static

Set the set to be used.

Parameters

  name | of the set to use

Returns
  true if it could be loaded

Definition at line 228 of file base_media_func.h.

The documentation for this class was generated from the following files:

- src/base_media_base.h
- src/base_media_func.h
- src/gfxinit.cpp
- src/music.cpp
- src/sound.cpp